<template>
  <Row class="stock-layout">
    <div class="stock-layout-background-color"></div>
    <Row class="body-block" v-if="displayBodyBlock">
      <Spin size="large" fix></Spin>
    </Row>
    <stock-head v-model="collapsed"></stock-head>
    <Row class="body">
      <div class="side-menu" :style="{left: sideMenuLeftPosition}" ref="sideMenu">
        <Row :gutter="8">
          <i-col v-for="(item, index) in sideMenus" :key="index"
            :span="12" class="menu-item-box pointer">
            <nuxt-link :to="{name: item.routeName}">
              <div class="menu-item" :class="isMatchRoute(item.routeName)">
                <div class="item-icon">
                  <Icon :type="item.icon" size="24"/>
                </div>
                <div class="item-title overflow-dot">{{item.title}}</div>
              </div>
            </nuxt-link>
          </i-col>
        </Row>
      </div>
      <Row class="main-content" @click.native="mainContentClickedAction">
        <slot></slot>
      </Row>
    </Row>
  </Row>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import StockHead from './StockHead';

const actions = {
  mainContentClickedAction() {
    // hide side menu
    this.collapsed = true;
    // hide user info box
    this.setDisplayUserInfoBox(false);
  },
};

export default {
  name: 'stock-layout',
  components: {
    'stock-head': StockHead,
  },
  props: {
    sideMenus: {
      type: Array,
      required: true,
    }
  },
  data() {
    return {
      collapsed: true,
      sideMenuLeft: '-460px',
    };
  },
  computed: {
    ...mapGetters('view', ['displayBodyBlock']),
    routeName() {
      return this.$route.name;
    },
    sideMenuLeftPosition() {
      if (this.$refs.sideMenu) {
        this.sideMenuLeft = `-${this.$refs.sideMenu.clientWidth}px`;
      }
      return (this.collapsed) ? this.sideMenuLeft : '0';
    }
  },
  watch: {
    routeName() {
      if (!this.collapsed) {
        this.collapsed = true;
      }
    }
  },
  methods: {
    ...mapActions('view', ['setDisplayUserInfoBox']),
    ...actions,
    isMatchRoute(itemRouteName) {
      return (this.routeName.includes(itemRouteName)) ? 'match-route' : undefined;
    }
  },
  mounted() {
    this.sideMenuLeft = `-${this.$refs.sideMenu.clientWidth}px`;
  }
}
</script>

<style lang="scss" scoped>
  @import "../assets/css/mixin.scss";

  .stock-layout {
    height: 100vh;
    background-image: url("/images/bull-background.jpg");
    background-size: cover;
    background-repeat: no-repeat;
    &::before {
      position: absolute;
      content: "";
      top: 0;
      left: 0;
      width: 100vw;
      height: 100vh;
    }
    .body-block {
      position: absolute;
      height: 100vh;
      width: 100vw;
      top: 0;
      left: 0;
      z-index: 2;
    }
    .body {
      height: calc(100% - 60px);
      overflow: auto;
      .side-menu {
        height: 100%;
        position: absolute;
        padding: 10px 20px;
        z-index: 9999;
        transition: left 0.3s linear;
        @media (max-width: $sm) {
          width: 100%;
        }
        @media (min-width: $sm) and (max-width: $md) {
          width: 50%;
        }
        @media (min-width: $md) and (max-width: $lg) {
          width: 50%;
        }
        @media (min-width: $lg) and (max-width: $xl) {
          width: 30%;
        }
        @media (min-width: $xl) and (max-width: $xxl) {
          width: 18%;
        }
        @media (min-width: $xxl) {
          width: 18%;
        }
        &:before {
          position: absolute;
          content: "";
          width: 100%;
          height: 100%;
          background-size: cover;
          z-index: -1;
          top: 0;
          left: 0;
        }
        .menu-item-box {
          .menu-item {
            height: 80px;
            padding: 10px 5px;
            border-radius: 4px;
            margin-top: 4px;
            margin-bottom: 4px;
            transition: box-shadow 0.5s;
            text-align: center;
              .item-icon {
                display: inline-block;
                width: 40px;
                height: 40px;
                border-radius: 4px;
                line-height: 40px;
                vertical-align: middle;
                text-align: center;
              }
              .item-title {
                width: 100%;
                height: 100%;
                padding: 5px;
                vertical-align: middle;
              }
          }
        }
      }
      .main-content {
        height: 100%;
        overflow-y: auto;
        z-index: 0;
      }
    }
  }
</style>
